{ lib, ... }: let
  tsHost = x: "http://${x}.hoki-porgy.ts.net";
  
  aliases = x: { serverAliases = x; };

  routes = [
    { 
      host = "warme.st"; 
      target = tsHost "honeydew"; 
      extra = aliases [ "colde.st" ]; 
    }
    { 
      host = "saerro.ps2.live"; 
      target = tsHost "durian"; 
      extra = aliases [ "agg.ps2.live" "metagame.ps2.live" ]; 
    }
    {
      host = "mx.sapphic.engineer";
      target = tsHost "mango";
      extra = aliases [ "i.mx.sapphic.engineer" ];
    }
    {
      host = "static-sites.foxxolay.net";
      target = tsHost "juniper";
      extra = aliases [ 
        "mekanoe.com" 
        "foxxolay.com" 
        "foxxolay.net" 
        "inaayoka.com" 
        "kat.cafe"
      ];
    }
    {
      host = "ml.colde.st";
      target = tsHost "lab-alpha";
      extra = {};
    }
  ];

  proxyConfig = {
    forceSSL = true;
    useHTTP3 = true;
    useHTTP2 = true;
    enableACME = true;
  };

  virtualHosts = {
    "m.la.mekanoe.com" = {
      locations."/".proxyPass = tsHost "lab-alpha";
    } // proxyConfig;
  };
in {
  imports = [
    ../../templates/proxmox-lxc.nix
    ../../server.nix
    ../../features/dns-cache.nix
    ../../features/nginx.nix
  ];

  networking.hostName = "ingress-proxy";
  system.stateVersion = "24.05"; 
  nixpkgs.hostPlatform = "x86_64-linux";

  services.nginx = {
    inherit virtualHosts;
    recommendedTlsSettings = true; 
  };
}
